/* Automatically generated from Squeak on #(29 July 2004 7:14:29 pm) */

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Default EXPORT macro that does nothing (see comment in sq.h): */
#define EXPORT(returnType) returnType

/* Do not include the entire sq.h file but just those parts needed. */
/*  The virtual machine proxy definition */
#include "sqVirtualMachine.h"
/* Configuration options */
#include "sqConfig.h"
/* Platform specific definitions */
#include "sqPlatformSpecific.h"

#define true 1
#define false 0
#define null 0  /* using 'null' because nil is predefined in Think C */
#ifdef SQUEAK_BUILTIN_PLUGIN
#undef EXPORT
// was #undef EXPORT(returnType) but screws NorCroft cc
#define EXPORT(returnType) static returnType
#endif
#include "V4LPlugin.h"

/* memory access macros */
#define byteAt(i) (*((unsigned char *) (i)))
#define byteAtput(i, val) (*((unsigned char *) (i)) = val)
#define longAt(i) (*((int *) (i)))
#define longAtput(i, val) (*((int *) (i)) = val)


/*** Variables ***/

#ifdef SQUEAK_BUILTIN_PLUGIN
extern
#endif
struct VirtualMachine* interpreterProxy;
static const char *moduleName =
#ifdef SQUEAK_BUILTIN_PLUGIN
	"V4LPlugin 29 July 2004 (i)"
#else
	"V4LPlugin 29 July 2004 (e)"
#endif
;

/*** Function Prototypes ***/
static int createDeviceIDwidthheightdepthpallete(int deviceID, int width, int height, int depth, int palette);
#pragma export on
EXPORT(const char*) getModuleName(void);
#pragma export off
static int halt(void);
static int height(Device device);
static int msg(char *s);
static int pixelbrightnesscontrast(int pixel, double brightness, double contrast);
#pragma export on
EXPORT(int) primitiveDeviceClose(void);
EXPORT(int) primitiveDeviceCreate(void);
EXPORT(int) primitiveDeviceDescribe(void);
EXPORT(int) primitiveDeviceGetHeight(void);
EXPORT(int) primitiveDeviceGetWidth(void);
EXPORT(int) primitiveDeviceNextFrameInto(void);
EXPORT(int) primitiveDeviceNextFrameIntoBrightnessAndContrast(void);
EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter);
#pragma export off
static int width(Device device);

static int createDeviceIDwidthheightdepthpallete(int deviceID, int width, int height, int depth, int palette) {
	return (int) createDevice(deviceID, width, height, depth, palette);
}


/*	Note: This is hardcoded so it can be run from Squeak.
	The module name is used for validating a module *after*
	it is loaded to check if it does really contain the module
	we're thinking it contains. This is important! */

EXPORT(const char*) getModuleName(void) {
	return moduleName;
}

static int halt(void) {
	;
}

static int height(Device device) {
	return device->vwindow.height;
}

static int msg(char *s) {
	fprintf(stderr, "\n%s: %s", moduleName, s);
}

static int pixelbrightnesscontrast(int pixel, double brightness, double contrast) {
    double c;
    int result;

	c = 1.0 + contrast;
	c = c * c;

	/* brightness */

	result = ((pixel - 0.5) * c) + 0.5;

	/* bound checking */

	result += ((int) (brightness * 256) );
	if (result < 0) {
		result = 0;
	}
	if (result > 255) {
		result = 255;
	}
	return result;
}

EXPORT(int) primitiveDeviceClose(void) {
    Device device;

	device = ((Device) (interpreterProxy->stackIntegerValue(0)));
	closeDevice(device);
	interpreterProxy->pop(1);
}

EXPORT(int) primitiveDeviceCreate(void) {
    int height;
    int depth;
    int width;
    int palette;
    int devicePointer;
    int deviceID;

	palette = interpreterProxy->stackIntegerValue(0);
	depth = interpreterProxy->stackIntegerValue(1);
	height = interpreterProxy->stackIntegerValue(2);
	width = interpreterProxy->stackIntegerValue(3);

	/*  */

	deviceID = interpreterProxy->stackIntegerValue(4);

	/*  */

	devicePointer = createDeviceIDwidthheightdepthpallete(deviceID, width, height, depth, palette);
	if (devicePointer <= 0) {
		return interpreterProxy->primitiveFail();
	}
	interpreterProxy->popthenPush(6, ((devicePointer << 1) | 1));
}

EXPORT(int) primitiveDeviceDescribe(void) {
    int deviceName;
    void* deviceNamePointer;
    int deviceNameSize;
    int deviceID;

	deviceName = interpreterProxy->stackValue(0);
	if (!(interpreterProxy->isBytes(deviceName))) {
		return interpreterProxy->primitiveFail();
	}
	deviceNamePointer = interpreterProxy->firstIndexableField(deviceName);
	deviceNameSize = interpreterProxy->byteSizeOf(deviceName);
	if (!(deviceNameSize == 32)) {
		return interpreterProxy->primitiveFail();
	}

	/*  */

	deviceID = interpreterProxy->stackIntegerValue(1);
	describeDevice(deviceID, deviceNamePointer);
	interpreterProxy->pop(2);
}

EXPORT(int) primitiveDeviceGetHeight(void) {
    Device device;
    int result;

	device = ((Device) (interpreterProxy->stackIntegerValue(0)));
	result = device->vwindow.height;
	interpreterProxy->popthenPush(2, ((result << 1) | 1));
}

EXPORT(int) primitiveDeviceGetWidth(void) {
    Device device;
    int result;

	device = ((Device) (interpreterProxy->stackIntegerValue(0)));
	result = device->vwindow.width;
	interpreterProxy->popthenPush(2, ((result << 1) | 1));
}


/*	set the capture extent and pixel format to use */

EXPORT(int) primitiveDeviceNextFrameInto(void) {
    int bitsArrayPointer;
    unsigned char* dest;
    unsigned char* final;
    unsigned char* src;
    Device device;
    int imageSize;
    int bitsArraySize;
    int result;

	bitsArrayPointer = interpreterProxy->stackValue(0);
	interpreterProxy->success(!(interpreterProxy->isPointers(bitsArrayPointer)));
	if (interpreterProxy->failed()) {
		return null;
	}

	/*  */

	bitsArraySize = interpreterProxy->byteSizeOf(bitsArrayPointer);

	/*  */

	device = ((Device) (interpreterProxy->stackIntegerValue(1)));
	result = nextFrameFromDevice(device);
	if (!(result)) {
		return interpreterProxy->primitiveFail();
	}
	imageSize = (width(device)) * (height(device));
	dest = ((unsigned char*) (bitsArrayPointer + 4));
	src = device->buffer24;

	/*  */

	final = dest + ((((imageSize * 3) < bitsArraySize) ? bitsArraySize : (imageSize * 3)));
	while (dest < final) {
		dest[0] = (src[2]);
		dest[1] = (src[1]);
		dest[2] = (src[0]);
		dest[3] = 255;
		dest += 4;
		src += 3;
	}
	interpreterProxy->pop(2);
}


/*	set the capture extent and pixel format to use */

EXPORT(int) primitiveDeviceNextFrameIntoBrightnessAndContrast(void) {
    double brightness;
    double contrast;
    unsigned char* src;
    int imageSize;
    int bitsArraySize;
    int result;
    unsigned char* dest;
    int bitsArrayPointer;
    unsigned char* final;
    Device device;

	contrast = interpreterProxy->stackFloatValue(0);
	brightness = interpreterProxy->stackFloatValue(1);
	brightness = (((((brightness < 1.0) ? brightness : 1.0)) < -1.0) ? -1.0 : (((brightness < 1.0) ? brightness : 1.0)));

	/*  */

	contrast = (((((contrast < 1.0) ? contrast : 1.0)) < -1.0) ? -1.0 : (((contrast < 1.0) ? contrast : 1.0)));
	bitsArrayPointer = interpreterProxy->stackValue(2);
	interpreterProxy->success(!(interpreterProxy->isPointers(bitsArrayPointer)));
	if (interpreterProxy->failed()) {
		return null;
	}

	/*  */

	bitsArraySize = interpreterProxy->byteSizeOf(bitsArrayPointer);

	/*  */

	device = ((Device) (interpreterProxy->stackIntegerValue(3)));
	result = nextFrameFromDevice(device);
	if (!(result)) {
		return interpreterProxy->primitiveFail();
	}
	imageSize = (width(device)) * (height(device));
	dest = ((unsigned char*) (bitsArrayPointer + 4));
	src = device->buffer24;

	/*  */

	final = dest + ((((imageSize * 3) < bitsArraySize) ? bitsArraySize : (imageSize * 3)));
	while (dest < final) {
		dest[0] = (pixelbrightnesscontrast(src[2], brightness, contrast));
		dest[1] = (pixelbrightnesscontrast(src[1], brightness, contrast));
		dest[2] = (pixelbrightnesscontrast(src[0], brightness, contrast));
		dest[3] = 255;
		dest += 4;
		src += 3;
	}
	interpreterProxy->pop(4);
}


/*	Note: This is coded so that is can be run from Squeak. */

EXPORT(int) setInterpreter(struct VirtualMachine* anInterpreter) {
    int ok;

	interpreterProxy = anInterpreter;
	ok = interpreterProxy->majorVersion() == VM_PROXY_MAJOR;
	if (ok == 0) {
		return 0;
	}
	ok = interpreterProxy->minorVersion() >= VM_PROXY_MINOR;
	return ok;
}

static int width(Device device) {
	return device->vwindow.width;
}


#ifdef SQUEAK_BUILTIN_PLUGIN


void* V4LPlugin_exports[][3] = {
	{"V4LPlugin", "primitiveDeviceClose", (void*)primitiveDeviceClose},
	{"V4LPlugin", "primitiveDeviceGetHeight", (void*)primitiveDeviceGetHeight},
	{"V4LPlugin", "primitiveDeviceDescribe", (void*)primitiveDeviceDescribe},
	{"V4LPlugin", "primitiveDeviceCreate", (void*)primitiveDeviceCreate},
	{"V4LPlugin", "primitiveDeviceNextFrameIntoBrightnessAndContrast", (void*)primitiveDeviceNextFrameIntoBrightnessAndContrast},
	{"V4LPlugin", "primitiveDeviceNextFrameInto", (void*)primitiveDeviceNextFrameInto},
	{"V4LPlugin", "getModuleName", (void*)getModuleName},
	{"V4LPlugin", "primitiveDeviceGetWidth", (void*)primitiveDeviceGetWidth},
	{"V4LPlugin", "setInterpreter", (void*)setInterpreter},
	{NULL, NULL, NULL}
};


#endif /* ifdef SQ_BUILTIN_PLUGIN */

